package test;
import static org.junit.Assert.*;
import static org.hamcrest.CoreMatchers.*;
import java.util.Iterator;

import kadai.TDUSet;

import org.junit.Before;
import org.junit.Test;
public class TDUSetTest {
	Integer[] array = {9,1,2,8,3,4,5,7,6};
	TDUSet<Integer> set1;
	TDUSet<Integer> set2;
	@Before
	public void setUp(){
		set1 = new TDUSet<Integer>(new Integer[0]);
		set2 = new TDUSet<Integer>(array);
	}
	@Test
	public void testSize() {
		assertThat(set1.size(),is(0));
		assertThat(set1.size(),is(0));
		assertThat(set2.size(),is(array.length));
		assertThat(set2.size(),is(array.length));
	}
	@Test
	public void testIterator() {
		Iterator<Integer> it1 = set1.iterator();
		assertThat(it1.hasNext(),is(false));
		Iterator<Integer> it2 = set2.iterator();
		for(int i=0 ; i< array.length; i++){
			assertThat(it2.hasNext(),is(true));
			assertThat(it2.next(),is(array[i]));
		}
		assertThat(it2.hasNext(),is(false));
	}
	@Test
	public void testToString0() {
		Integer[] expect;
		expect = new Integer[0];
		assertArrayEquals(expect,set1.toArray());
		expect = new Integer[]{9, 1, 2, 8, 3, 4, 5, 7, 6};
		assertArrayEquals(expect,set2.toArray());
	}
}
