package test;
import static org.junit.Assert.*;
import static org.hamcrest.CoreMatchers.*;
import java.util.Map;
import kadai.TDUMapEntry1;
import kaitou.TDUMap3;
import org.junit.Test;
public class TDUMap3Test {
	@Test
	public void testPutStringInteger() {
		Map<String,Integer> map = new TDUMap3();
		TDUMapEntry1[] expect;
		expect=new TDUMapEntry1[0];
		assertArrayEquals(expect,map.entrySet().toArray());

		assertThat(map.put("jkl",12),is(nullValue()));
		expect=new TDUMapEntry1[]{new TDUMapEntry1("jkl",12)};
		assertArrayEquals(expect,map.entrySet().toArray());

		assertThat(map.put("jkl",13),is(12));
		expect=new TDUMapEntry1[]{new TDUMapEntry1("jkl",13)};
		assertArrayEquals(expect,map.entrySet().toArray());

		assertThat(map.put("def",456),is(nullValue()));
		expect=new TDUMapEntry1[]{
				new TDUMapEntry1("def",456),
				new TDUMapEntry1("jkl",13)
		};
		assertArrayEquals(expect,map.entrySet().toArray());

		assertThat(map.put("mno",345),is(nullValue()));
		expect=new TDUMapEntry1[]{
				new TDUMapEntry1("def",456),
				new TDUMapEntry1("jkl",13),
				new TDUMapEntry1("mno",345)
		};
		assertArrayEquals(expect,map.entrySet().toArray());

		assertThat(map.put("abc",123),is(nullValue()));
		expect=new TDUMapEntry1[]{
				new TDUMapEntry1("abc",123),
				new TDUMapEntry1("def",456),
				new TDUMapEntry1("jkl",13),
				new TDUMapEntry1("mno",345)
		};
		assertArrayEquals(expect,map.entrySet().toArray());

		assertThat(map.put("ghi",789),is(nullValue()));
		expect=new TDUMapEntry1[]{
				new TDUMapEntry1("abc",123),
				new TDUMapEntry1("def",456),
				new TDUMapEntry1("ghi",789),
				new TDUMapEntry1("jkl",13),
				new TDUMapEntry1("mno",345)
		};
		assertArrayEquals(expect,map.entrySet().toArray());

		assertThat(map.put("pqr",678),is(nullValue()));
		expect=new TDUMapEntry1[]{
				new TDUMapEntry1("abc",123),
				new TDUMapEntry1("def",456),
				new TDUMapEntry1("ghi",789),
				new TDUMapEntry1("jkl",13),
				new TDUMapEntry1("mno",345),
				new TDUMapEntry1("pqr",678)
		};
		assertArrayEquals(expect,map.entrySet().toArray());

		assertThat(map.put(new String("jkl"),901),is(13));
		expect=new TDUMapEntry1[]{
				new TDUMapEntry1("abc",123),
				new TDUMapEntry1("def",456),
				new TDUMapEntry1("ghi",789),
				new TDUMapEntry1("jkl",901),
				new TDUMapEntry1("mno",345),
				new TDUMapEntry1("pqr",678)
		};
		assertArrayEquals(expect, map.entrySet().toArray());

		assertThat(map.put("ABC",456),is(nullValue()));
		expect=new TDUMapEntry1[]{
				new TDUMapEntry1("ABC",456),
				new TDUMapEntry1("abc",123),
				new TDUMapEntry1("def",456),
				new TDUMapEntry1("ghi",789),
				new TDUMapEntry1("jkl",901),
				new TDUMapEntry1("mno",345),
				new TDUMapEntry1("pqr",678)
		};
		assertArrayEquals(expect,map.entrySet().toArray());

		assertThat(map.put("def",234),is(456));
		expect=new TDUMapEntry1[]{
				new TDUMapEntry1("ABC",456),
				new TDUMapEntry1("abc",123),
				new TDUMapEntry1("def",234),
				new TDUMapEntry1("ghi",789),
				new TDUMapEntry1("jkl",901),
				new TDUMapEntry1("mno",345),
				new TDUMapEntry1("pqr",678)
		};
		assertArrayEquals(expect,map.entrySet().toArray());

		assertThat(map.put("mno",567),is(345));
		expect=new TDUMapEntry1[]{
				new TDUMapEntry1("ABC",456),
				new TDUMapEntry1("abc",123),
				new TDUMapEntry1("def",234),
				new TDUMapEntry1("ghi",789),
				new TDUMapEntry1("jkl",901),
				new TDUMapEntry1("mno",567),
				new TDUMapEntry1("pqr",678)
		};
		assertArrayEquals(expect,map.entrySet().toArray());
	}
}
